function registerPushwooshIOS() {
 	var pushNotification = window.plugins.pushNotification;

	document.addEventListener('push-notification', function(event) {
				var notification = event.notification;
				navigator.notification.alert(notification.aps.alert);

				//to view full push payload
				//navigator.notification.alert(JSON.stringify(notification));

				//reset badges on icon
				pushNotification.setApplicationIconBadgeNumber(0);
			  });

	pushNotification.registerDevice({alert:true, badge:true, sound:true, pw_appid:"418BD-05D35", appname:"SIdP"},
									function(status) {
										var deviceToken = status['deviceToken'];
										//alert('registerDevice: ' + deviceToken);
										onPushwooshiOSInitialized(deviceToken);
									},
									function(status) {
										//alert('failed to register : ' + JSON.stringify(status));
										navigator.notification.alert(JSON.stringify(['failed to register ', status]));
									});

	//reset badges on start
	pushNotification.setApplicationIconBadgeNumber(0);
}

function onPushwooshiOSInitialized(pushToken)
{
	var pushNotification = window.plugins.pushNotification;
	//retrieve the tags for the device
	pushNotification.getTags(function(tags) {
								//alert('tags for the device: ' + JSON.stringify(tags));
							 },
							 function(error) {
								//alert('get tags error: ' + JSON.stringify(error));
							 });

	//start geo tracking. PWTrackSignificantLocationChanges - Uses GPS in foreground, Cell Triangulation in background. 
	pushNotification.startLocationTracking('PWTrackSignificantLocationChanges',
									function() {
										   //alert('Location Tracking Started');
									});
}

function registerPushwooshAndroid() {

 	var pushNotification = window.plugins.pushNotification;

	//push notifications handler
	document.addEventListener('push-notification', function(event) {
	            var title = event.notification.title;
	            var userData = event.notification.userdata;

	            //dump custom data to the console if it exists
	            if(typeof(userData) != "undefined") {
					//alert('user data: ' + JSON.stringify(userData));
				}

				//and show alert
				navigator.notification.alert(title);

				//stopping geopushes
				pushNotification.stopGeoPushes();
			  });

	//projectid: "GOOGLE_PROJECT_ID", appid : "PUSHWOOSH_APP_ID"
	pushNotification.registerDevice({ projectid: "187047161912", appid : "418BD-05D35" },
									function(token) {
										//alert(token);
										//callback when pushwoosh is ready
										onPushwooshAndroidInitialized(token);
									},
									function(status) {
										//alert("failed to register: " +  status);
									    //alert(JSON.stringify(['failed to register ', status]));
									});
 }

function onPushwooshAndroidInitialized(pushToken)
{
	//output the token to the console
	//alert('push token: ' + pushToken);

	var pushNotification = window.plugins.pushNotification;

	pushNotification.getTags(function(tags) {
							//alert('tags for the device: ' + JSON.stringify(tags));
						 },
						 function(error) {
							//alert('get tags error: ' + JSON.stringify(error));
						 });


	//set multi notificaiton mode
	//pushNotification.setMultiNotificationMode();
	//pushNotification.setEnableLED(true);

	//set single notification mode
	//pushNotification.setSingleNotificationMode();

	//disable sound and vibration
	//pushNotification.setSoundType(1);
	//pushNotification.setVibrateType(1);

	pushNotification.setLightScreenOnNotification(false);

	//goal with count
	//pushNotification.sendGoalAchieved({goal:'purchase', count:3});

	//goal with no count
	//pushNotification.sendGoalAchieved({goal:'registration'});

	//setting list tags
	//pushNotification.setTags({"MyTag":["hello", "world"]});

	//settings tags
	pushNotification.setTags({deviceName:"hello", deviceId:10},
									function(status) {
										//alert('setTags success');
									},
									function(status) {
										//alert('setTags failed');
									});

	function geolocationSuccess(position) {
		pushNotification.sendLocation({lat:position.coords.latitude, lon:position.coords.longitude},
								 function(status) {
									  //alert('sendLocation success');
								 },
								 function(status) {
									  //alert('sendLocation failed');
								 });
	};

	// onError Callback receives a PositionError object
	//
	function geolocationError(error) {
		/* alert('code: '    + error.code    + '\n' +
			  'message: ' + error.message + '\n'); */
	}

	function getCurrentPosition() {
		navigator.geolocation.getCurrentPosition(geolocationSuccess, geolocationError);
	}

	//greedy method to get user position every 3 second. works well for demo.
//	setInterval(getCurrentPosition, 3000);

	//this method just gives the position once
//	navigator.geolocation.getCurrentPosition(geolocationSuccess, geolocationError);

	//this method should track the user position as per Phonegap docs.
//	navigator.geolocation.watchPosition(geolocationSuccess, geolocationError, { maximumAge: 3000, enableHighAccuracy: true });

	//Pushwoosh Android specific method that cares for the battery
	pushNotification.startGeoPushes();
}

 function initPushwoosh() {
	
	var pushNotification = window.plugins.pushNotification;
	if(device.platform == "Android")
	{
		registerPushwooshAndroid();
		pushNotification.onDeviceReady();
	}

	if(device.platform == "iPhone" || device.platform == "iOS")
	{
		registerPushwooshIOS();
		pushNotification.onDeviceReady();
	}
	
}
